import {AfterContentInit, Component, OnInit} from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { Store, select } from '@ngrx/store';
import { FormGroup, FormBuilder, Validators } from '@angular/forms';

import * as TotpStore from 'packages/member/store/totp';
import { AuthSelector } from 'packages/member/store';
import { TotpSelector } from 'packages/member/store';
import { Member } from 'packages/member/model/Member';
import {MemberTotp} from '../../../model/MemberTotp';

@Component({
  selector: 'of-settings-totp',
  templateUrl: './totp.component.html',
  styleUrls: ['./totp.component.scss']
})
export class TotpComponent implements OnInit, AfterContentInit {
  member: Member;
  selectedItem: any;
  totpSettingDisplay = false;
  errorMessage: string | null;
  totpForm: FormGroup;
  headerItem: string;
  totpVO: MemberTotp;

  formErrors = {
    'code': '',
  };

  lists = [];

  constructor(private activatedRoute: ActivatedRoute,
              private router: Router,
              private store: Store<TotpStore.State>,
              private formBuilder: FormBuilder,
              ) { }

  ngOnInit() {
    this.totpForm = this.formBuilder.group({
      'code': [
        [
        ]
      ]
    });
  }

  ngAfterContentInit() {

    this.store.select(AuthSelector.select('member')).subscribe(
      (member: Member) => {
        this.member = member;
        this.lists = [
          {id: 1, name: 'Email', value: this.member.email, description: 'blabla', },
          {id: 2, name: 'Phone', value: this.member.phone, description: 'blabla', },
          {id: 3, name: 'Google 2factor', value: this.member.totpType, description: 'blabla', },
        ];
      },
      (error) => {
        console.log(error);
      }
    );

    // this.listStore.select(AuthSelector.select('member')).subscribe(
    //   (member: Member) => {
    //     this.store.dispatch(new TotpRegistStore.createTotp(member));
    //   },
    //   (error) => {
    //     console.log(error);
    //   }
    // );
    //
    // this.probes$.subscribe(
    //   (probes: boo) => {
    //     console.log(probes);
    //     this.dataSource = new MatTableDataSource(probes);
    //     this.dataSource.sort = this.sort;
    //   },
    //   (error: RPCError) => {
    //     console.log(error.response.message);
    //   }
    // );

  }

  on2factorConfig(event: Event, item: any) {
    this.selectedItem = item;

    // server totp regist member info modify
    if (this.selectedItem.id === 3) {
      this.headerItem = '구글 인증기 설정하기';
      this.totpSettingDisplay = true;
      // dispatch
    }
  }

  onTotpSettingClose() {
    this.totpSettingDisplay = false;
  }
  registClick() {
    const code = this.totpForm.value['code'];
    const secretCode = 'X6AWAK573M5372NM';

    this.store.select(AuthSelector.select('member')).subscribe(
      (member: Member) => {
        this.store.dispatch(new TotpStore.Regist({ member, secretCode, code }));
      },
      (error) => {
        console.log(error);
      }
    );
  }
}
